#include <kernel/include.h>
#include <drivers/serial/serial.h>
#include <drivers/lcd/define.h>

void task1();
void task2();
void task3();


int C_Entry()
{

		Arch_Init();
		Kern_Init();
		Kern_IOSubBuild();

		Kern_ThreadCreate(1, &task1,1,0);
		Kern_ThreadCreate(2, &task2,2,0);
		Kern_ThreadCreate(3, &task3,3,0);
		OSTimer0_IRQ_Init();

		Kern_Sched();
		while(1) {;}

		return 0;
}


void task1()
{
		char err;
		dev_op_t *console;

		volatile int i;
		volatile int j = 0;

		console = Kern_GetDevOp(0, &err);

		lcd_init(8);
		lcd_on();

		//if (LOAD_FILE((char *)PAL_ADDRESS, (char *)DATA_ADDRESS)) return (3);
		LcdModeApp(8);
		//SetLcdPalette(PAL);
		//lcd_on();
#if 0
		_Interrupt_disable();
		console->Write("GPDR0= %x");
		SerialOutputHex(*((unsigned int *)0x40e0000c));
		console->Write(" \n");
		console->Write("GPDR1= %x");
		SerialOutputHex(*((unsigned int *)0x40e00010));
		console->Write(" \n");
		console->Write("GPDR2= %x");
		SerialOutputHex(*((unsigned int *)0x40e00004));
		console->Write(" \n");
		console->Write("GPSR0= %x");
		SerialOutputHex(*((unsigned int *)0x40e00018));
		console->Write(" \n");
		console->Write("GPSR1= %x");
		SerialOutputHex( *((unsigned int *)0x40e0001c));
		console->Write(" \n");
		console->Write("GPSR2= %x");
		SerialOutputHex( *((unsigned int *)0x40e00020));
		console->Write(" \n");

		console->Write("GPAR0_L= %x");
		SerialOutputHex( *((unsigned int *)0x40e00054));
		console->Write(" \n");
		console->Write("GPAR0_H= %x");
		SerialOutputHex( *((unsigned int *)0x40e00058));
		console->Write(" \n");
		console->Write("GPAR1_L= %x");
		SerialOutputHex( *((unsigned int *)0x40e0005c));
		console->Write(" \n");
		console->Write("GPAR1_H= %x");
		SerialOutputHex( *((unsigned int *)0x40e00060));
		console->Write(" \n");
		console->Write("GPAR2_L= %x");
		SerialOutputHex( *((unsigned int *)0x40e00064));
		console->Write(" \n");

		console->Write("GPAR2_H= %x");
		SerialOutputHex( *((unsigned int *)0x40e00068));
		console->Write("\n");
		_Interrupt_enable();
#endif 
		for (;;){
				j= 0;
				console->Write("task1!\n");

				CRITICAL_SECTION_ENTER();
				lcd_putchar('A');	
				CRITICAL_SECTION_LEAVE();
		}
}



void task2()
{
		char err;
		dev_op_t *console;

		console = Kern_GetDevOp(0, &err);

		volatile int i;
		volatile int j = 0;
		for (;;){
				console->Write("task2?\n");
		}
}

void task3()
{
		char err;
		dev_op_t *console;

		console = Kern_GetDevOp(0, &err);
		for (;;){
				console->Write("task3?\n");
		}
}






